// ------------------------------------------------------------ //
// Author   : This file has been written by Yann Renard         //
// Copyright: This file is totaly free and you may distribute   //
//            it to anyone you want, without modifying this     //
//            header. If you use it in a commercial project (?) //
//            or in bigger project (!), I would be glad to know //
//            about it :) Please mail me...                     //
//            be glad to know about it, please mail me          //
//                myself_yr@hotmail.com                         //
// ------------------------------------------------------------ //

#ifndef BONEIO_H
#define BONEIO_H

// Reading part
inline char readChar(FILE *in)
{
  return fgetc(in);
}

inline short readShort(FILE *in)
{
  char b1 = fgetc(in);
  char b2 = fgetc(in);
  return (b1<<8) + b2;
}

inline int readInt(FILE *in)
{
  unsigned char b1 = fgetc(in);
  unsigned char b2 = fgetc(in);
  unsigned char b3 = fgetc(in);
  unsigned char b4 = fgetc(in);
  unsigned int result;
  result = b1;
  result <<= 8; result += b2;
  result <<= 8; result += b3;
  result <<= 8; result += b4;
  return result;
}

inline float readFloat(FILE *in)
{
  int value = readInt(in);
  float *valuePtr = (float *) &value;
  return *valuePtr;
}

inline char *readString(FILE *in, char *str)
{
  int cpt=0;
  while ((str[cpt++] = readChar(in)) != '\0');
  return str;
}

// Writing part
inline void writeChar(FILE *out, char data)
{
  fputc(data, out);
}

inline void writeShort(FILE *out, short data)
{
  fputc((data>>8) & 255, out);
  fputc( data     & 255, out);
}

inline void writeInt(FILE *out, int data)
{
  fputc((data>>24) & 255, out);
  fputc((data>>16) & 255, out);
  fputc((data>>8 ) & 255, out);
  fputc( data      & 255, out);
}

inline void writeFloat(FILE *out, float data)
{
  int *dataPtr = (int *) &data;
  writeInt(out, *dataPtr);
}

inline void writeString(FILE *out, char *data)
{
  int cpt = 0;
  while (data[cpt] != '\0')
    fputc(data[cpt++], out);
  fputc(data[cpt], out);
}

#endif // BONEIO_H
