#ifndef BUTTON_H
#define BUTTON_H

#define BUTTON_TYPE	12
#define BUTTON_NAME	"Button"
#define BUTTON_INIT	buttonInitFuncList
#define BUTTON_LASTING	0.07	// 70 ms
#define BUTTON_PROPS	1

#define BUTTON_PROPSTATE 0

/**
 * Button Class
 */
class Button: public WObject {
 public:
  char *refname;	///< object instance name
  uint8_t method0;	///< action if on
  uint8_t method1;	///< action if off

  static const WClass wclass;	// class variable
  static const uint8_t props;
  virtual const WClass* getWClass() {return &wclass;};

  Button(char *l);

  static WObject * (creator)(char *l);

  virtual void updateTime(time_t, time_t, float *);
  virtual bool updateToNetwork(const Pos &oldpos);
  virtual void quit();
};

void BUTTON_INIT(void);

#endif // BUTTON_H
